Bug 116374 - [GTK] [CMake] Build the plugin process against GTK+ 2
Summary: [GTK] [CMake] Build the plugin process against GTK+ 2
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit Gtk (show other bugs)
Version: 528+ (Nightly build)
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Martin Robinson
URL:
Keywords:
Depends on:
Blocks: 115966
  Show dependency treegraph
 
Reported: 2013-05-17 19:29 PDT by Martin Robinson
Modified: 2013-12-17 13:50 PST (History)
5 users (show)

See Also:


Attachments
Patch (29.25 KB, patch)
2013-12-12 02:17 PST, Martin Robinson
no flags Details | Formatted Diff | Diff
Patch fixing small dependency issue (30.49 KB, patch)
2013-12-15 23:49 PST, Martin Robinson
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Robinson 2013-05-17 19:29:58 PDT
The WebKit2 plugin process currently links against libwebkit2gtk which itself links against GTK+ 3. Since most plugins link against GTK+ 2 we need the plugin process to link against GTK+ 2.
Comment 1 Martin Robinson 2013-12-12 02:17:28 PST
Created attachment 219061 [details]
Patch
Comment 2 Martin Robinson 2013-12-15 23:49:28 PST
Created attachment 219298 [details]
Patch fixing small dependency issue
Comment 3 Gustavo Noronha (kov) 2013-12-17 04:33:45 PST
Comment on attachment 219298 [details]
Patch fixing small dependency issue

View in context: https://bugs.webkit.org/attachment.cgi?id=219298&action=review

Not for review yet?

> Source/WebKit2/PlatformGTK.cmake:484
> +    # FIXME: We should figure out a way to avoid compiling files that are common between the plugin
> +    # process and WebKit2 only once instead of recompiling them for the plugin process.

Maybe build them into an intermediate library that is linked by both?
Comment 4 Martin Robinson 2013-12-17 04:42:04 PST
(In reply to comment #3)
> (From update of attachment 219298 [details])
> View in context: https://bugs.webkit.org/attachment.cgi?id=219298&action=review
> 
> Not for review yet?

Oops! webkit-patch was broken recently and I uploaded it manually.

> > Source/WebKit2/PlatformGTK.cmake:484
> > +    # FIXME: We should figure out a way to avoid compiling files that are common between the plugin
> > +    # process and WebKit2 only once instead of recompiling them for the plugin process.
> 
> Maybe build them into an intermediate library that is linked by both?

I think that's the best solution. It requires removing the files from the shared source list and then adding them to an intermediate library. It seemed a bit too much for this patch, so I hope it can be tackled later.
Comment 5 Gustavo Noronha (kov) 2013-12-17 06:09:23 PST
Comment on attachment 219298 [details]
Patch fixing small dependency issue

View in context: https://bugs.webkit.org/attachment.cgi?id=219298&action=review

>>> Source/WebKit2/PlatformGTK.cmake:484
>>> +    # process and WebKit2 only once instead of recompiling them for the plugin process.
>> 
>> Maybe build them into an intermediate library that is linked by both?
> 
> I think that's the best solution. It requires removing the files from the shared source list and then adding them to an intermediate library. It seemed a bit too much for this patch, so I hope it can be tackled later.

Absolutely!
Comment 6 Martin Robinson 2013-12-17 13:49:03 PST
Committed r160728: <http://trac.webkit.org/changeset/160728>